#!/usr/bin/python
# -*- coding: utf-8 -*-
#
# dp report function
#
# Copyright(C) 2012 MUNEDA Takahiro
# Copyright(C) 2012 FUJITSU LIMITED
#

import sys

import dp
import dp_compat


def main():
    '''
    Call Report() to collect system information
    Return value(int): success -> 0, error -> 1
    '''
    return dp.Report()


def pre_main():
    '''
    Check command argument and system environment before processing main().
    Return value(int): return value from main()
    '''
    dp_compat.report_parse_args()

    dp.AvoidOom()
    if dp.CheckEnvironment():
        return 1

    retval = main()
    dp.CleanupPIDFile()
    return retval


if __name__ == '__main__':
    sys.exit(pre_main())
