#!/usr/bin/python
# -*- coding: utf-8 -*-
#
# Send DR operation ready IPMI command
#
# Copyright(C) 2013 MUNEDA Takahiro
# Copyright(C) 2013 FUJITSU LIMITED
#

# This program is called via FJSVdr-util-RHEL6(initscript) or
# dp-send-ready.service(systemd)

import sys

import dp
import ipmi


def main():
    '''
    Send IPMI command to notify DR operation is ready on this system
    Return value(int): success -> 0, error -> 1
    '''
    retval = ipmi.SendOSReady()
    if retval:
        dp.LogErr('631 : Failed to send IPMI Command: OS Ready')
    return retval


if __name__ == '__main__':
    sys.exit(main())
